/* 
        CellStatic.cc

	MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
	X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)

	codeshimarinwin maslβŸ򸵤Yamahata
        ޤ
*/

#include <string.h>

#include "CellStatic.h"

CellStatic::CellStatic (MaslInputStream& maslIs,const unsigned char ak5ID):
  Cell (maslIs,ak5ID)
{
  //ŪdataXImageѴ
  //8bit˷ᤦ
  imageData=new unsigned char[PLANE_LENGTH*8];
  memset (imageData,basePixel,PLANE_LENGTH*8);//memroy
  imageMask=new char[PLANE_LENGTH/8];
  memset (imageMask,0,PLANE_LENGTH/8);
  
  if (!(Cell::extractCell2XImage (cellData,imageData)))//Ÿ
  {
    exit (-1);
  }
  delete[] cellData;//ѤѤʬФϤĤФѺѤߡ
  cellData=NULL;
}

CellStatic::~CellStatic ()
{
  delete[] imageData;
  delete[] imageMask;
}

void CellStatic::GRCG2XImage (const int address,
			      unsigned char* const imagePointer)
{
  Cell::GRCG2XImage (address,imagePointer);

  /* *(imageMask+address)=True; */
  //imageMaskƬaddressܤbitΩƤ
  //0x80=10000000
  *(imageMask+(address/8))|=(0x80 >> (address%8));
}


Bool CellStatic::extractCell2XImage (XImage* const ximage,
				     const int offset=0,
				     const int gdcLoop=PLANE_LENGTH)
{
  return extractCell2XImage ((unsigned char*) ximage->data,offset,gdcLoop);
}

Bool CellStatic::extractCell2XImage (unsigned char* const image,
				     const int offset=0,
				     const int gdcLoop=PLANE_LENGTH)
{
  //Ϥäȸⲽͭ롣ΤޤޤǤܡ
  //offset<0ȤʤΤGDC scrollȤäƤǤꡢ
  //λθʤȤʤextractCell.ccǤƱ͡
  int tmpOffset=offset%VRAM_LENGTH;
  assert (-gdcLoop<=tmpOffset);
  assert (tmpOffset<VRAM_LENGTH);

/*
#ifdef DEBUG
  cerr << "offset   =" << offset << endl;
  cerr << "tmpOffset=" << tmpOffset << endl;
  cerr << "gdcLoop     =" << gdcLoop << endl;
#endif  
*/
  for (int i=0;i<PLANE_LENGTH;i++)
    {
      //if (imageMask[i])
      if (( (*(imageMask+(i/8)))&(0x80 >> (i%8)) )!=0)
	{//imageMaskƬiܤbitΩäƤ褹
	  memcpy (image+
		  ((tmpOffset+i>=0)?
		   ((tmpOffset+i)%VRAM_LENGTH)*8:
		   (tmpOffset+i+gdcLoop)*8),
		  imageData+i*8,8);	  
	}
    }

  return True;
}
