/* 
        CellStaticLowMemory.cc

	MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
	X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)

	codeshimarinwin maslβŸ򸵤Yamahata
        ޤ
*/

#include <string.h>
//#include <cstring>

#include "CellStaticLowMemory.h"

CellStaticLowMemory::CellStaticLowMemory (MaslInputStream& maslIs,
					  const unsigned char ak5ID):
  Cell (maslIs,ak5ID)
{
  //ŪdataXImageѴ
  //8bit˷ᤦ
  imageData=new unsigned char[PLANE_LENGTH*8/2];
  memset (imageData,0,PLANE_LENGTH*8/2);//memroy
  imageMask=new char[PLANE_LENGTH/8];
  memset (imageMask,0,PLANE_LENGTH/8);
  
  if (!(Cell::extractCell2XImage (cellData,imageData)))//Ÿ
  {
    exit (-1);
  }
  delete[] cellData;//ѤѤʬФϤĤФѺѤߡ
  cellData=NULL;
}

CellStaticLowMemory::~CellStaticLowMemory ()
{
  delete[] imageData;
  delete[] imageMask;
}

void CellStaticLowMemory::GRCG2XImage (const int address,
				       unsigned char* const imagePointer)
{
  int tmpAddress=((address+offset>=0)?
                  address+offset:(address+offset+gdcLoop));
  
  tmpAddress%=VRAM_LENGTH;
  assert (0<=tmpAddress);
  for (int i=0;i<8;i++)
    {
      //b=plane 0,r=plane 1,g=plane 2,e=plane 3Ǥա
      store4 (imagePointer,tmpAddress*8+i,
	      ((((gdc.b << i)&0x80) >> 7)|(((gdc.r << i)&0x80) >> 6)|
	       (((gdc.g << i)&0x80) >> 5)|(((gdc.e << i)&0x80) >> 4)));
    }

  //imageMaskƬaddressܤbitΩƤ
  //0x80=10000000
  *(imageMask+(address/8))|=(0x80 >> (address%8));
}


Bool CellStaticLowMemory::extractCell2XImage (XImage* const ximage,
				     const int offset=0,
				     const int gdcLoop=PLANE_LENGTH)
{
  return extractCell2XImage ((unsigned char*) ximage->data,offset,gdcLoop);
}

Bool CellStaticLowMemory::extractCell2XImage (unsigned char* const image,
				     const int offset=0,
				     const int gdcLoop=PLANE_LENGTH)
{
  //Ϥäȸⲽͭ롣ΤޤޤǤܡ
  //offset<0ȤʤΤGDC scrollȤäƤǤꡢ
  //λθʤȤʤextractCell.ccǤƱ͡
  int tmpOffset=offset%VRAM_LENGTH;
  assert (-gdcLoop<=tmpOffset);
  assert (tmpOffset<VRAM_LENGTH);

  for (int i=0;i<PLANE_LENGTH;i++)
    {
      if (( (*(imageMask+(i/8)))&(0x80 >> (i%8)) )!=0)
	{//imageMaskƬiܤbitΩäƤ褹
#if 0 //áΤޤޤǤ٤ʤäƤޤ
	  for (int j=0;j<8;j++)
	    {
	      *(image+j+
		((tmpOffset+i>=0)?
		 ((tmpOffset+i)%VRAM_LENGTH)*8:
		 (tmpOffset+i+gdcLoop)*8))=
		palette2Pixel[retrieve4 (imageData,i*8+j)];
	    }
#endif
	  *(image+
	    ((tmpOffset+i>=0)?
	     ((tmpOffset+i)%VRAM_LENGTH)*8:
	     (tmpOffset+i+gdcLoop)*8))=
	    palette2Pixel[(imageData[(i*8)/2])&15];
	  *(image+1+
	    ((tmpOffset+i>=0)?
	     ((tmpOffset+i)%VRAM_LENGTH)*8:
	     (tmpOffset+i+gdcLoop)*8))=
	    palette2Pixel[(imageData[(i*8)/2] >> 4)&15];
	  *(image+2+
	    ((tmpOffset+i>=0)?
	     ((tmpOffset+i)%VRAM_LENGTH)*8:
	     (tmpOffset+i+gdcLoop)*8))=
	    palette2Pixel[(imageData[(i*8+2)/2])&15];
	  *(image+3+
	    ((tmpOffset+i>=0)?
	     ((tmpOffset+i)%VRAM_LENGTH)*8:
	     (tmpOffset+i+gdcLoop)*8))=
	    palette2Pixel[(imageData[(i*8+2)/2] >> 4)&15];
	  *(image+4+
	    ((tmpOffset+i>=0)?
	     ((tmpOffset+i)%VRAM_LENGTH)*8:
	     (tmpOffset+i+gdcLoop)*8))=
	    palette2Pixel[(imageData[(i*8+4)/2])&15];
	  *(image+5+
	    ((tmpOffset+i>=0)?
	     ((tmpOffset+i)%VRAM_LENGTH)*8:
	     (tmpOffset+i+gdcLoop)*8))=
	    palette2Pixel[(imageData[(i*8+4)/2] >> 4)&15];
	  *(image+6+
	    ((tmpOffset+i>=0)?
	     ((tmpOffset+i)%VRAM_LENGTH)*8:
	     (tmpOffset+i+gdcLoop)*8))=
	    palette2Pixel[(imageData[(i*8+6)/2])&15];
	  *(image+7+
	    ((tmpOffset+i>=0)?
	     ((tmpOffset+i)%VRAM_LENGTH)*8:
	     (tmpOffset+i+gdcLoop)*8))=
	    palette2Pixel[(imageData[(i*8+6)/2] >> 4)&15];
	}
    }
  return True;
}
