/* 
        palette.h

	MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
	X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)

	shimarincode򸵤Yamahata񤤤ʪǤ
*/
//C++
#include <iostream.h>

//C
#include <stdio.h>
//#include <cstdio>
#include <assert.h>
//#include <casert>

//X
#include <X11/Xlib.h>
#include <X11/Xutil.h>

#include "MaslConst.h"
#include "MaslInputStream.h"
#include "Masl.h"

#ifndef palette_h
#define palette_h

struct PALETTE
{
  unsigned char r,g,b;
};

class Palette      
{
  //variables
private:
  static Display* display;//color mapꤹdisplay
  static Colormap colormap;//ꤹcolor map
  char fileName[17];//file name
  PALETTE palette[NUMBER_OF_COLORS];//palette
  static unsigned long palette2Pixel[NUMBER_OF_COLORS];
  //palette number->pixel value
  static PALETTE paletteOfNow[NUMBER_OF_COLORS];
  //ꤵƤpalette(â뤵ޤǤϴޤޤʤ)
  inline static void setXColor (XColor& xcolor,const int paletteNumber,
				const int r,const int g,const int b,
				const int contrast=100)
    {
      xcolor.pixel=palette2Pixel[paletteNumber];
      xcolor.flags=DoRed|DoGreen|DoBlue;
#if 0
      xcolor.red  =(r*contrast/100) << 12;
      xcolor.green=(g*contrast/100) << 12;
      xcolor.blue =(b*contrast/100) << 12;
#endif
      xcolor.red  =((unsigned short) r << 12)*contrast/100;
      xcolor.green=((unsigned short) g << 12)*contrast/100;
      xcolor.blue =((unsigned short) b << 12)*contrast/100;
    }
  
  
  //methods
public:
  Palette (MaslInputStream& maslIs);
  ~Palette ();
  static void preparePalette (Display* const maslDisplay,
			      const Colormap maslColormap,
			      const unsigned long planes[DEPTHOFAK5],
			      const unsigned long basePixel);
  void setPalette (const int contrast=100);
  static void setPalette (const int paletteNumber,
			  const int r,const int g,const int b,
			  const int contrast=100);
  static void setTone (const int contrast);
  static void mix (const int paletteNumber1,const int paletteNumber2,
		   const int ratio,const int contrast=100);
  //paletteNumber11֤paletteNumber2֤
  //ѥåȤ򤽤줾ratio(100-ratio)󺮤ѥåȤ
  //contrastϥȡ͡

  
};
#endif //palette_h
