/* 
        maslCommand.cc

        MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
        X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)

        codeshimarincode򸵤Yamahataľʪǡ
        ˽񤭴Ƥޤ
*/
#include "Masl.h"
#include "audio.h"
#include "MaslAudio.h"
#include "CellAhead.h"

/////////////////////////////////////////////////////////////
void Masl::cmdLeftBracket (Masl& masl)
{
  /*
    '['']'̵¥롼
    '[n'  ']':n롼
    '@n''rn'ϻǤޤ
    '[=P1,P2'  ']':P1=P2ΩĤʤ롼
    ƱͤʤΤȤơ'[!P1,P2'(P1P2ΰ),'[<P1,P2','[<=P1,P2','[>P1,P2',
    '[>=P1,P2'¸ߤޤʰʲΥޥɤˤĤƤƱ͡
    '['  ']=P1,P2':P1=P2ΩĤʤ롼סʸȽ
    */
  masl.pt++;
  switch (*masl.pt)
    {
    case 'r':
      //'ret'(1.2)
      //ɽˡϡ'rateP1'
      //ɽˡϡ'rollP1[,P2]'(1.1,408׎ݤǤΥ롼פ1.2
      if ((*(masl.pt+1)=='e' && *(masl.pt+2)=='t') ||
	  (*(masl.pt+1)=='a' && *(masl.pt+2)=='t' && *(masl.pt+3)=='e')||
	  (*(masl.pt+1)=='o' && *(masl.pt+2)=='l' && *(masl.pt+3)=='l'))
	{//Ƚޤ̵loopä
	  masl.loopCounter[masl.numberOfLoop++]=-1;
	  return;
	}
      else
	{//loopä
	  masl.loopCounter[masl.numberOfLoop++]=masl.searchnum ();
	  return;
	}
      break;

    case 'p':
      //ɽˡϡ'palP1[,P2]'
      //ɽˡϡ'pal_P1,r,g,b'(1.2)
      //ɽˡϡ'pcmP1[,P2][.]'
      //ɽˡϡ'pdP1'
      //ɽˡϡ'pstP1'(1.1)
      //ɽˡϡ'pwP1'
      //ɽˡϡ'pwtP1'
      if ((*(masl.pt+1)=='a' && *(masl.pt+2)=='l') ||
	  (*(masl.pt+1)=='c' && *(masl.pt+2)=='m') ||
	  (*(masl.pt+1)=='d') ||
	  (*(masl.pt+1)=='s' && *(masl.pt)=='t') ||
	  (*(masl.pt+1)=='w'))
	{//Ƚޤ̵loopä
	  masl.loopCounter[masl.numberOfLoop++]=-1;
	  return;
	}
      else
	{//loopä
	  masl.loopCounter[masl.numberOfLoop++]=masl.searchnum ();
	  return;
	}
      break;

    case 'o':
      //'outP1,P2'(1.1)
      //'o2u'
      if ((*(masl.pt+1)=='u' && *(masl.pt+2)=='t') ||
	  (*(masl.pt+1)=='2' && *(masl.pt+2)=='u'))
	{//Ƚޤ̵loopä
	  masl.loopCounter[masl.numberOfLoop++]=-1;
	  return;
	}
      else
	{//loopä
	  masl.loopCounter[masl.numberOfLoop++]=masl.searchnum ();
	  return;
	}
      break;

    case '0'://ľ
    case '1'://ľ
    case '2'://ľ
    case '3'://ľ
    case '4'://ľ
    case '5'://ľ
    case '6'://ľ
    case '7'://ľ
    case '8'://ľ
    case '9'://ľ
    case '@'://ľ
    case 'k'://loopä
      masl.loopCounter[masl.numberOfLoop++]=masl.searchnum ();
      return;
      break;
    
    case '='://ľ
    case '!'://ľ
    case '>'://ľ
    case '<'://loopä
      if (!masl.joukenHantei ())
	{//looploopΩ
	  //νޤФ
	  int cnt=0;
	  while (*masl.pt!=']'||cnt!=0)
	    {
	      if (*masl.pt=='[')
		cnt++;
	      if (*masl.pt==']')
		cnt--;
	      masl.pt++;
	    }
	  masl.pt++;
	  return;
	}
      else
	{//loopΩ
	  masl.loopCounter[masl.numberOfLoop++]=-1;
	  return;
	}
      break;

    default://Ƚޤ̵loopä
      masl.loopCounter[masl.numberOfLoop++]=-1;
      return;
      break;
    }
}



void Masl::cmdRightBracket (Masl& masl)
{
  if (masl.numberOfLoop<0 || //ʤפȦ
      masl.loopCounter[masl.numberOfLoop-1]==-1)
    {//̵loopޤϸloopʤ
      /*
	#ifdef DEBUG
	cerr << "atohanntei is called." << endl;
	#endif
	*/
      const char* ppt=masl.pt;
      masl.pt++;
      masl.numberOfLoop--;
      switch (*masl.pt)
	{
	case '='://ľ
	case '!'://ľ
	case '<'://ľ
	case '>'://Ƚloopä
	  if (!masl.joukenHantei ())//loopΩ
	    break;
	  //ľ loopΩ
	default://loopʤΤб[
	  masl.pt=ppt-1;
	  int cnt=0;
	  while (*masl.pt!='['||cnt!=0)
	    {//б'['
	      if (*masl.pt=='[')
		cnt--;
	      if (*masl.pt==']')
		cnt++;
	      masl.pt--;
	    }
	  break;
	}
      return;
    }
  else
    {//loopʤ
      if (--masl.loopCounter[masl.numberOfLoop-1]>0)
	{//ޤloopĤäƤ
	  int cnt=0;
	  masl.pt--;
	  while (*masl.pt!='['||cnt!=0)
	    {//б[(])
	      if (*masl.pt=='[')
		cnt++;
	      if (*masl.pt==']')
		cnt--;
	      masl.pt--;
	    }
	  masl.pt++;//skip [
	  masl.searchnum ();//loopФ
	  return;
	}
      else
	{//loopλ
	  masl.numberOfLoop--;
	  masl.pt++;
	  return;
	}
    }
}

void Masl::cmdLeftBrace (Masl& masl)
{//'{=P1,P2'  '}':P1=P2ΩĤʤ'{'  '}'ʬ¹
  //'{=P1,P2'  '}else{'  '}':
  //P1=P2ΩĤʤ'{'  '}else{'ʬ¹ԡ
  //Ωʤʤ'}else{'  '}'ޤǤ¹
  masl.pt++;
  if (!masl.joukenHantei ())
    {//Ω
      int cnt=0;
      while (*masl.pt!='}'||cnt!=0)
	{//б'}'ޤФ
	  if (*masl.pt=='{')
	    cnt++;
	  if (*masl.pt=='}')
	    cnt--;
	  masl.pt++;
	}
      masl.pt++;
      masl.searchNextCommand ();
      if (masl.pt[0]=='e' && masl.pt[1]=='l' &&
	  masl.pt[2]=='s' && masl.pt[3]=='e')
	{
	  masl.pt+=4;
	  masl.searchNextCommand ();
	  if (*masl.pt!='{')
	    {
	      cerr << "syntax error:{=P1,P2}else{}"<< endl;
	      return;
	    }
	  if (*(masl.pt+1)!='=' && *(masl.pt+1)!='!' &&
	      *(masl.pt+1)!='<' && *(masl.pt+1)!='>')
	    {//{}else{}else{}...else{}Ǿ郎Ω˺Ǹ{}
	      //ʤΤǤϼ¹ԤΤǡФФ
	      masl.pt+=1;
	    }
	  return;
	}
    }
}


void Masl::cmdRightBrace (Masl& masl)
{
  masl.pt++;
  masl.searchNextCommand ();
  while (masl.pt[0]=='e' && masl.pt[1]=='l' &&
	 masl.pt[2]=='s' && masl.pt[3]=='e')
    {//{}else{}else{}...else{}Ǿ郎Ω˺Ǹ{}
      //ʤΤǤϼ¹ԤΤǡФФ
      //whileǤΤ{}else{}else{}else{}...else{}ȤʤäƤΰ١
      masl.pt+=4;
      masl.searchNextCommand ();
      if (*masl.pt!='{')
	{
	  cerr << "syntax error:else{}" << endl;
	  return;
	  //return False;
	}
      masl.pt++;
      int cnt=0;
      while (*masl.pt!='}'||cnt!=0)
	{
	  if (*masl.pt=='{')
	    cnt++;
	  if (*masl.pt=='}')
	    cnt--;
	  masl.pt++;
	}
      masl.pt++;

      masl.searchNextCommand ();
    }
}

void Masl::cmdLabel (Masl& masl)
{//labelʬФ
  masl.pt++;
  masl.searchnum ();
}


void Masl::cmdJump (Masl& masl)
{//jP1:P1κֹΥ٥ض
  //j=P1,P2 P3:P1=P2ΩĤʤ顢P3κֹΥ٥إ
  masl.pt++;
  switch (*masl.pt)
    {
    case '='://ľ
    case '!'://ľ
    case '>'://ľ
    case '<'://jampä
      if (!masl.joukenHantei ())
	{//ΩjumpΥ٥ֹФ
	  masl.pt++;
	  (void) masl.searchnum ();
	  break;
	}
	//ľ loopΩ
    default://Ūlabelޤǰư
      while (*masl.pt==' ')
	masl.pt++;      
      {
	int n=masl.getValue ();
	masl.pt=masl.scenario->getBeginPoint ();
	int ln;
	do
	  {//٥ΰ֤ޤǰư
	    while (*masl.pt!='#')
	      {//#n:٥ʤΤǤޤpointerʤ롣
		masl.pt++;
	      }
	    masl.pt++;
	    ln=masl.searchnum ();
	  }while (ln!=n);
      }
      break;
    }
}


void Masl::cmdCall (Masl& masl)
{//callP1:P1κֹΥ٥
  //call=P1,P2 P3P1=P2ΩĤʤ顢P3κֹΥ٥call
  masl.pt+=4;
	      
  switch (*masl.pt)
    {
    case '='://ľ
    case '!'://ľ
    case '>'://ľ
    case '<'://callä
      if (!masl.joukenHantei ())
	break;//callΩ
      //ľ callΩ
    default://call
      while (*masl.pt==' ')
	{
	  masl.pt++;
	}
      {
	int n=masl.getValue ();
	//callФƤ
	masl.callStack[masl.numberOfCall++]=masl.pt;
	//٥call
	masl.pt=masl.scenario->getBeginPoint ();
	int ln;
	do
	  {
	    while (*masl.pt!='#')
	      {//٥pointer֤ޤǿʤ
		masl.pt++;
	      }
	    masl.pt++;
	    ln=masl.searchnum ();
	  }while (ln!=n);//ŪΥ٥뤫
      }
      break;
    }
}


void Masl::cmdRet (Masl& masl)
{//ret:줵ξޤ
  //ͥȤϣ³
  if (!masl.numberOfCall)
    {
      cerr << "error:ret" << endl;
      masl.pt+=3;//skip ret
      return;
      //return False;
    }
  masl.pt=masl.callStack[--masl.numberOfCall];
}


///////////////////////////////////////////////////////////////////////math

void Masl::cmdLet (Masl& masl)
{//=@n,P1:@n=P1
  masl.pt+=2;
  int n=masl.getValue ();
  masl.pt++;//skip comma
  masl.intVar[n]=masl.getValue ();
}

  
void Masl::cmdPlus (Masl& masl)
{//+@n,P1:@n+=P1
  masl.pt+=2;
  int n=masl.getValue ();
  masl.pt++;//skip ccmma
  masl.intVar[n]+=masl.getValue ();
}

  
void Masl::cmdMinus (Masl& masl)
{//-@n,P1:@n-=P1
  masl.pt+=2;
  int n=masl.getValue ();
  masl.pt++;//skip comma
  masl.intVar[n]-=masl.getValue ();
}

  
void Masl::cmdTimes (Masl& masl)
{//'*@n,P1:@n*=P1'
  masl.pt+=2;
  int n=masl.getValue ();
  masl.pt++;//commaФ
  masl.intVar[n]*=masl.getValue ();
}

  
void Masl::cmdDivide (Masl& masl)
{//@n,P1:@n/=P1
  masl.pt+=2;
  int n=masl.getValue ();
  masl.pt++;//commaФ
  int m=masl.getValue ();
  assert (m!=0);
  masl.intVar[n]/=m;
}

  
void Masl::cmdModulo (Masl& masl)
{//%@n,P1:@n%=P1
  masl.pt+=2;
  int n=masl.getValue ();
  masl.pt++;//commaФ
  masl.intVar[n]%=masl.getValue ();
}

  
void Masl::cmdAnd (Masl& masl)
{//&@n,P1:@n%=P1
  masl.pt+=2;
  int n=masl.getValue ();
  masl.pt++;//commaФ
  masl.intVar[n]&=masl.getValue ();
}

  
void Masl::cmdOr (Masl& masl)
{//|@n,P1:@n^=P1
  masl.pt+=2;
  int n=masl.getValue ();
  masl.pt++;//commaФ
  masl.intVar[n]|=masl.getValue ();
}

  
void Masl::cmdXor (Masl& masl)
{//^@n,P1:@n^=P1
  masl.pt+=2;
  int n=masl.getValue ();
  masl.pt++;//commaФ
  masl.intVar[n]^=masl.getValue ();
}

  
///////////////////////////////////////////////////////////graphics 

void Masl::cmdGon (Masl& masl)
{//gonեåɽˤ
  masl.pt+=3;
  masl.isGraphicOn=True;
  masl.updateWindow ();
  XFlush (masl.display);
}

  
void Masl::cmdGoff (Masl& masl)
{//goff:եåɽˤ
  masl.pt+=4;
  masl.isGraphicOn=False;
  //masl.clearWindow ();//줬ɬפɤɤäͤ
  masl.updateWindow ();
  XFlush (masl.display);
}

  
void Masl::cmdLine (Masl& masl)
{//line4:̤򣴣饤⡼ɤˤ
  //line2:̤򣲣饤⡼ɤˤ
  masl.pt+=4;
  switch (*masl.pt++)
    {
    case '2':
      //400line modemode̵200line modeˤ롣
      if (!masl.xmaslOption.isForce400LineMode)
	masl.is200LineMode=True;
      break;

    case '4':
      masl.is200LineMode=False;
      break;
      
    default:
      cerr << "syntax error:line" << endl;
      break;
    }
  //ɬפɤͤȤƤϤɤäʤΤǤ礦
  Cell::GDCRollImageData (masl.imageData[0],-masl.nVramOrg,masl.gdcLoop);
  Cell::GDCRollImageData (masl.imageData[1],-masl.nVramOrg,masl.gdcLoop);
  masl.nVramOrg=0;
  masl.updateWindow ();
}


void Masl::cmdPw (Masl& masl)
{//pwP1:pageP1ˤ
  masl.pt+=2;
  int n=masl.getValue ();
  assert (n==0||n==1);
  n=abs (n)%2;
  masl.nDrawPage=n;
}


void Masl::cmdPd (Masl& masl)
{//pdP1:ɽpageP1ˤ
  masl.pt+=2;
  int n=masl.getValue ();
  assert (n==0||n==1);
  n=abs (n)%2;
  masl.nShowPage=n;
  masl.updateWindow ();
  XFlush (masl.display);
}

  
void Masl::cmdD (Masl& masl)
{//dP1[,P2[,P3]]
  //P1ܤΣãǤ(P2,P3)ΰ֤ɽP2,P3Ȥά0
  masl.pt++;

  int n=masl.getValue ();

  /////ꤵ줿ֹ椬ϰϤͭ뤫check
  assert (0<=n);
  assert (n<masl.getNumberOfCells ());
  //cerr << "n=" << n << endl;
  n=abs (n)%masl.getNumberOfCells ();//ϻͤʤΤ

  int x=0,y=0;
  if (*masl.pt==',')
    {
      masl.pt++;//commaФ
      x=masl.getValue ();
      if (*masl.pt==',')
	{
	  masl.pt++;//commaФ
	  y=masl.getValue ();
	}
    }
    
  int offset=x+y*(SIZE_X/8)-masl.nVramOrg*2;
  //ϤɤΤ
  //GDCRollμ˰¸Ƥޤ

  if (masl.aheadlyExtractedCellNumber==n)
    {//ŸƤΤǤȤ
      masl.cellAhead->extractCell2XImage (masl.imageData[masl.nDrawPage],
					   offset,masl.gdcLoop);
    }
  else
    {//̾Ÿ
      masl.pCell[n]->extractCell2XImage (masl.imageData[masl.nDrawPage],
					  offset,masl.gdcLoop);
    }
  if (masl.nDrawPage==masl.nShowPage)
    {
      masl.updateWindow ();
      XFlush (masl.display);
    }
}


  
void Masl::cmdCls (Masl& masl)
{//cls:̾õ
  masl.pt+=3;
  masl.clearWindow ();
  masl.updateWindow ();
  XFlush (masl.display);
}


void Masl::cmdBox (Masl& masl)
{//box x1,y1,x2,y2,b,r,g,e(x1,y1)-(x2,y2)ϰϤλͳѷ褹
  //b,r,g,eϡ줾Υץ졼˽Ϥ͡
  masl.pt+=3;
  const int x1=masl.getValue ();
  masl.pt++;//skip comma
  const int y1=masl.getValue ();
  masl.pt++;//skip comma
  const int x2=masl.getValue ();
  masl.pt++;//skip comma
  const int y2=masl.getValue ();
  masl.pt++;//skip comma
  const int b=masl.getValue ();
  masl.pt++;//skip comma
  const int r=masl.getValue ();
  masl.pt++;//skip comma
  const int g=masl.getValue ();
  masl.pt++;//skip comma
  const int e=masl.getValue ();
  Cell::drawBox (masl.imageData[masl.nDrawPage],x1,y1,x2,y2,b,r,g,e);

  if (masl.nDrawPage==masl.nShowPage)
    {
      masl.updateWindow ();
      XFlush (masl.display);
    }
}


void Masl::cmdO2u (Masl& masl)
{//o2u:vrampage0page1ž
  masl.pt+=3;
  Cell::copyImage (masl.imageData[0],masl.imageData[1]);

  if (masl.nDrawPage==1)
    {
      masl.updateWindow ();
      XFlush (masl.display);
    }
}


void Masl::cmdU2o (Masl& masl)
{//u2o:vrampage1page0ž
  masl.pt+=3;
  Cell::copyImage (masl.imageData[1],masl.imageData[0]);

  if (masl.nDrawPage==0)
    {
      masl.updateWindow ();
      XFlush (masl.display);
    }
}


void Masl::cmdPal (Masl& masl)
{//palP1[,P2]:P1ܤΥѥåȥǡP2ΰŤꤹ
  //P2άϣ
  masl.pt+=3;
  masl.nPalette=masl.getValue ();

  ///////////////////////ꤵ줿paletteֹ椬ϰϤͭ뤫check
  assert (0<=masl.getCurrentPaletteNumber ());
  assert (masl.getCurrentPaletteNumber ()<masl.getNumberOfPalettes ());
  masl.nPalette=abs (masl.nPalette)%(masl.getNumberOfPalettes ());

  int contrast=100;
  if (*masl.pt==',')
    {
      masl.pt++;
      contrast=masl.getValue ();
    }
  masl.pPalette[masl.nPalette]->setPalette (contrast);
  XFlush (masl.display);
}


void Masl::cmdPalNum (Masl& masl)
{//pal_P1,r,g,bP1֤ΥѥåȤr,g,bꤹ
  masl.pt+=4;
  int nPalette=masl.getValue ();
  ///////////ꤵ줿paletteֹ椬ϰϤͭ뤫check
  assert (0<=nPalette);
  assert (nPalette<16);
  nPalette=abs (nPalette)%16;

  masl.pt++;//skip comma
  int r=masl.getValue ();
  masl.pt++;//skip comma
  int g=masl.getValue ();
  masl.pt++;//skip comma
  int b=masl.getValue ();

  Palette::setPalette (nPalette,r,g,b);
  XFlush (masl.display);
}


void Masl::cmdMove (Masl& masl)
{//move x1,y1,x2,y2,x3,y3:(x1,y1)-(x2,y2)ϰϤ(x3,y3)ž
  masl.pt+=4;
  RECT src;
  src.left    =masl.getValue ();
  masl.pt++;//skip comma
  src.top     =masl.getValue ();
  masl.pt++;//skip comma
  src.right   =masl.getValue ();
  masl.pt++;//skip comma
  src.bottom  =masl.getValue ();
  masl.pt++;//skip comma
  int destLeft=masl.getValue ();
  masl.pt++;//skip comma
  int destTop =masl.getValue ();
  Cell::moveRect (masl.imageData[masl.nDrawPage],src,destLeft,destTop);
  if (masl.nDrawPage==masl.nShowPage)
    {
      masl.updateWindow ();
      XFlush (masl.display);
    }
}


void Masl::cmdRoll (Masl& masl)
{//roll
  /*
    ɽˡϡ'rollP1[,P2]'(1.1,408饤ǤΥ롼פ1.2)
    εǽ  ̤ɽϰ֤P1(GDCɥ쥹ˤĤɥåñ)
    P20ξϲ̤ϣ饤ʬǥ롼פ(˽ĥ
    )ξϣ֣ңͤθ³(32768Х)ǥ롼פ롣
    ޤξϣ饤ǥ롼פΤǡĥ
    ʤ̳ǽ񤭴ԤȤǤ롣(άϣ)
       'roll40' - Ĥˣɥåȥ
    ʤʤƻǤĤǲʤͤϣǣģäٶƤ
    */
  masl.pt+=4;
  int GDCRoll=masl.nVramOrg;
  masl.nVramOrg=masl.getValue ();
  GDCRoll=masl.nVramOrg-GDCRoll;//Ūvramɤ餹

  int n=0;
  if (*masl.pt==',')
    {
      masl.pt++;
      n=masl.getValue ();
      assert (n==0||n==1||n==2);
    }

  switch (n)
    {
    case 0:
      masl.gdcLoop=PLANE_LENGTH;//=SIZE_X*SIZE_Y/8=640*400/8=32000
      break;
    case 1:
      masl.gdcLoop=VRAM_LENGTH;
      break;
    case 2:
      masl.gdcLoop=SIZE_X*408/8;//640*408/8=32640;
      break;
    default:
      cerr << "syntax err:rollP1[,P2] P2=0 or 1 or 2" << endl;
      //return False;
      break;
    }
	      
  Cell::GDCRollImageData (masl.imageData[0],GDCRoll,masl.gdcLoop);
  Cell::GDCRollImageData (masl.imageData[1],GDCRoll,masl.gdcLoop);

  masl.updateWindow ();
  XFlush (masl.display);
}


void Masl::cmdTone (Masl& masl)
{//toneP1ѥåȤΰŤP1ꤹ
  masl.pt+=4;
  int contrast=masl.getValue ();
  assert (0<=contrast);
  assert (contrast<=100);
  
  Palette::setTone (contrast);
  XFlush (masl.display);
}


void Masl::cmdMask (Masl& masl)
{//mask x1,y1,x2,y2:̤ɽϰϤ(x1,y1)-(x2,y2)ꤹ
  //ޥʬοϡѥåȤ˴طʤˤʤޤʥƥȤѤΰ١
  masl.pt+=4;
  masl.viewPort.left  =masl.getValue ();
  masl.viewPort.top   =masl.getValue ();
  masl.viewPort.right =masl.getValue ();
  masl.viewPort.bottom=masl.getValue ();

  if (!masl.xmaslOption.useMask)
    {//maskǽѤʤΤǲΤɽ褦ꡣ
      masl.viewPort.left  =0;
      masl.viewPort.top   =0;
      masl.viewPort.right =SIZE_X-1;
      masl.viewPort.bottom=SIZE_Y-1;
    }

  if (masl.xmaslOption.isFullsize)
    {//full size modeʤΤviewport98 vram礭
      masl.viewPort.left  =0;
      masl.viewPort.top   =0;
      masl.viewPort.right =SIZE_X-1;
      masl.viewPort.bottom=VRAM_SIZE_Y-1;
    }
  

  XClearWindow (masl.display,masl.window);
  masl.updateWindow ();
  XFlush (masl.display);
}

void Masl::cmdPmix (Masl& masl)
{
  //'pmixP1,P2,P3[,P4]'ޥɤˤꡢP1֤P2֤
  //ѥåȤ򤽤줾P3(100-P3)󺮤ѥåȤ
  //Ǥ褦˲ɡP4ϥȡ͡
  masl.pt+=3;
  int paletteNumber1=masl.getValue ();
  masl.pt++;//skip comma
  int paletteNumber2=masl.getValue ();
  masl.pt++;//skip comma
  const int ratio=masl.getValue ();
  /////////////////////ϰϤͭ뤫check
  assert (0<=paletteNumber1);
  assert (paletteNumber1<=masl.getNumberOfPalettes ());
  assert (0<=paletteNumber2);
  assert (paletteNumber2<=masl.getNumberOfPalettes ());
  assert (0<=ratio);
  assert (ratio<=100);
  paletteNumber1=abs (paletteNumber1)%masl.getNumberOfPalettes ();
  paletteNumber2=abs (paletteNumber2)%masl.getNumberOfPalettes ();

  int contrast=100;
  if (*masl.pt==',')
    {
      masl.pt++;
      contrast=masl.getValue ();
      assert (0<=contrast);
      assert (contrast<=100);
    }
  Palette::mix (paletteNumber1,paletteNumber2,ratio,contrast);
  XFlush (masl.display);
  return;
}

///////////////////////////////////////////////////////////////pcm
void Masl::cmdPcm (Masl& masl)
{//pcmP1[,P2][.]:P1ܤΣУãͤP2ܤΥͥȯ
  //ʺǸ˥ԥꥪɤդ뤳ȤˤꡢУãͤΥ롼פǽ
  //P2άϡƤͥưŪ˻Ѥޤ
  //̾ϤǽʬǤưꤷȤϣ˶ᤤͥ뤫
  //Ѥ褦ˤƤʣ˶ŤۤɽŤʤ
  masl.pt+=3;
  int nPcm=masl.getValue ();
  //////////////////ϰϤͭ뤫check
  nPcm%=masl.getNumberOfPcm ();
  
  Bool isLoop=False;
  
  int channel=-1;//=-1ϼưŪchannel
  if (*masl.pt==',')
    {
      masl.pt++;//skip comma
      channel=masl.getValue ();
      /////////////////channelꤷcheck
      assert (0<=channel);
      assert (channel<=8);
    }
  if (*masl.pt=='.')
    {
      isLoop=True;
      masl.pt++;
    }
  masl.pPcm[nPcm]->play (channel,isLoop);
}


void Masl::cmdRate (Masl& masl)
{//ɽˡϡ'rateP1'
  //εǽ  УãͤΥ졼ȤP1
  //   'rate16540' - 졼Ȥ򣱣ȣ
  //Υޥɤ¹ԤȡȯΣУãͤߤޤ
  masl.pt+=4;
  int rate=masl.getValue ();
  if (!(MaslAudio::setSampleRate (rate)))
    {
      cerr << "can not (re)set sample rate.(Rate=" << rate << ")" 
	   << endl;
      cerr << "PCM data may be played at wrong rate." << endl;
    }
}


void Masl::cmdPst (Masl& masl)
{//pstP1
  //P1ΩäƤӥåȤκУãͤκߤ
  //μǤԴ
  masl.pt+=3;
  const int channel=masl.getValue ();
  
  MaslAudio::stopAudio (channel);
}

  
void Masl::cmdPwt (Masl& masl)
{//pwtP1
  //P1ΩäƤӥåȤλؤУãͤκߤޤޤԤ
  //μǤԴ
  masl.pt++;
  char channelMask=(char) masl.getValue ();
  ///////////////////////////check
  assert (0<=channelMask);
  //assert (channelMask<=15);
  
#ifdef MIX_AUDIO
  masl.isAudioWaiting=channelMask;
#else
  masl.isAudioWaiting=0xff;
#endif
}

////////////////////////////////////////////timer counter

void Masl::cmdCount (Masl& masl)
{//countP1ޥȤô֤P1/100ʤ褦
  masl.pt+=5;
  masl.timer.setCount (masl.getValue ());
}


void Masl::cmdTc (Masl& masl)
{//tc:ޥ󥿤ν(0ˤ)
  //gettimeofday (&masl.dwTickCount,NULL);
  masl.timer.clearTimer ();
  masl.pt+=2;
  if (isdigit (*masl.pt)||*masl.pt=='r'||*masl.pt=='@'||
      *masl.pt=='k'||*masl.pt=='o'||*masl.pt=='p')
    {//tcP1:ޥȤ,P1ˤʤޤԤġ
      masl.timeCntForWait=masl.getValue ();
      masl.isWaiting=True;
      //Ÿ
      extractCellAhead (masl);
    }
}


void Masl::cmdT (Masl& masl)
{//tP1:ޥȤP1ˤʤޤԤġ
  masl.pt++;
  masl.timeCntForWait=masl.getValue ();

  if (masl.timer.getNowCount ()<(long)masl.timeCntForWait*100)
    {//ԤɬפͭԤ
      masl.isWaiting=True;

      //Ÿ.
      extractCellAhead (masl);

      return;
    }
  //Ԥɬפ̵ä٤Ƥ
  masl.timeCntForWait=0;
  if (*masl.pt=='c')//tP1cä
    {
      masl.timer.clearTimer ();
      masl.pt++;
    }
}


////////////////////////////////////////////////////////etc.

void Masl::cmdOut (Masl& masl)
{//'outP1,P2':P1ΥݡȤP2
  masl.pt+=3;
  masl.getValue ();//бʤΤǡͤɤ߼Τơ
  masl.pt++;//skip comma
  masl.getValue ();//бʤΤǡͤɤ߼Τơ
  cerr << "outP1,P2 is called." << endl;
  cerr << "this function is not implemented." << endl;
  cerr << "this statement is ignored." << endl;
}

void Masl::cmdError (Masl& masl)
{//'errP1,P2':λ˥顼٥֤
  //P1ｪλP2escǽλȤ͡
  //error level֤ȸΤϤɤʤΤǤ礦
  masl.pt+=3;
  masl.normalExit=masl.getValue ();
  masl.pt++;//skip comma
  masl.escapeExit=masl.getValue ();
  masl.errorLevel=&masl.normalExit;//error level̾ｪλꡣ
}


void Masl::cmdComment (Masl& masl)
{//ޤǥȤʤΤǹޤФ
  while (!(*(masl.pt-2)=='\r' && *(masl.pt-1)=='\n'))
    masl.pt++;
}

/////////////////////////////////////////Ÿ
//Ÿֹmasl.isCellAheadlyExtractedNumber֤
//Ÿʤ-1֤
void Masl::extractCellAhead (Masl& masl)
{
  if (!masl.xmaslOption.isAhead||
      masl.xmaslOption.isStatic||masl.xmaslOption.isStaticLowMemory)
    return;//optionŸ̵ˤʤäƤ롢ޤŪŸƤʤŸס(ʤ)

  ////////////////////////////commandɤ
  int offset=1;  /////  *(pt-1)=='t'ʤΤǤʬʤ롣
  Bool isIntVarChanged=False;//ѿȤ줿

  ////////////////////////////'dP1'Ȥ̿᤬ͭޤǿʤ롣
  while ((*(masl.pt+offset-2)=='o' || *(masl.pt+offset-1)=='o' ||
	  *(masl.pt+offset-1)=='k' || *(masl.pt+offset-1)=='p') ||
	 *(masl.pt+offset)!='d')
    {
      if (*(masl.pt+offset)==']' ||
	  (*(masl.pt+offset)=='[' &&
	   (*(masl.pt+offset+1)=='=' || *(masl.pt+offset+1)=='<' ||
	    *(masl.pt+offset+1)=='<' || *(masl.pt+offset+1)=='>' )) ||
	  *(masl.pt+offset)=='{' ||
	  *(masl.pt+offset)=='}' ||
	  *(masl.pt+offset)=='j' ||
	  *(masl.pt+offset)=='\\' ||
	  (*(masl.pt+offset)=='c' && *(masl.pt+offset+1)=='a' &&
	   *(masl.pt+offset+2)=='l' && *(masl.pt+offset+3)=='l') ||
	  (*(masl.pt+offset)=='r' && *(masl.pt+offset)=='e'
	   && *(masl.pt+offset)=='t') ||
	  masl.scenario->isEnd (masl.pt+offset)
	  )
	return;////ʬgotoͭвŸǰ
      
      if ((*(masl.pt+offset-1)=='=' || *(masl.pt+offset-1)=='+' || 
	   *(masl.pt+offset-1)=='-' || *(masl.pt+offset-1)=='*' ||
	   *(masl.pt+offset-1)=='/' || *(masl.pt+offset-1)=='%' ||
	   *(masl.pt+offset-1)=='&' || *(masl.pt+offset-1)=='|' ||
	   *(masl.pt+offset-1)=='^') &&
	  *(masl.pt+offset)=='@')
	isIntVarChanged=True;//ѿѹ줿check
      offset++;
    }

  offset++;//skip 'd'
  if (!(isdigit (*(masl.pt+offset)) ||
	(*(masl.pt+offset)=='@' || !isIntVarChanged)))return;
  //'d'ΰ̵ޤѿǤäƤ⤽ޤǤѿѹƤ
  //ʤŸǰ(ɤѿѹƤƤ)

  ///////////////////////////Ÿη
  int nOfCell;
  if (*(masl.pt+offset)=='@')
    {//ѿä
      int l;
      offset++;
      if (*(masl.pt+offset)=='@')
	{
	  offset++;
	  l=masl.intVar[masl.searchnum (masl.pt+offset)];
	  while (isdigit (*(masl.pt+offset)))
	    offset++;
	}
      else
	{
	  l=masl.searchnum(masl.pt+offset);
	  while (isdigit (*(masl.pt+offset)))
	    offset++;
	}

      int m=1;
      if (*(masl.pt+offset)=='*')
	{
	  offset++;
	  m=masl.searchnum (masl.pt+offset);
	  while (isdigit (*(masl.pt+offset)))
	    offset++;
	}

      int n=0;
      if (*(masl.pt+offset)=='+')
	n=masl.searchnum (masl.pt+offset);
      
      nOfCell=masl.intVar[l]*m+n;
    }
  else
    {//ä
      nOfCell=masl.searchnum (masl.pt+offset);
    }
  assert (0<=nOfCell);
  assert (nOfCell<masl.getNumberOfCells ());
  nOfCell=abs (nOfCell)%masl.getNumberOfCells ();//ϻͤʤΤ
  
  ////////////////////////////Ÿ
  if (masl.cellAhead==NULL)
    {//ƸƤӽФ줿Τǽ롣
      masl.cellAhead=new CellAhead ();
    }
  masl.cellAhead->extractCellAhead (masl.pCell[nOfCell]);
  masl.aheadlyExtractedCellNumber=nOfCell;
}

