.\" groff -Tnippon -man xmasl.man
.\"
.\" MASL/M-MASL Copyright (c) KUNI/TDU
.\" Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
.\" X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)
.\"
.TH XMASL 1x "27 June 1997" "Release 6" "X Version 11"
.SH NAME
xmasl \- masl(Memorymapped Animation Scenario Language) player for X Window System
.SH SYNOPSIS
.B xmasl
[
.B \-abcdefhmnpRrSstw
]
[
.B \-\-ahead
]
[
.B \-\-break
]
[
.B \-\-comment
]
[
.B \-\-commentless
]
[
.B \-\-debug
]
[
.B \-\-demand
]
[
.B \-\-euc
]
[
.B \-\-force400line
]
[
.B \-\-full
]
[
.B \-\-help
]
[
.B \-\-mask
]
[
.B \-\-maskless
]
[
.B \-\-mitshm
]
[
.B \-\-normal
]
[
.B \-\-nosound
]
[
.B \-\-pause
]
[
.B \-\-RENICE
]
[
.B \-\-resizable
]
[
.B \-\-realtime
]
[
.B \-\-STATIC
]
[
.B \-\-static
]
[
.B \-\-sjis
]
[
.B \-\-sound
]
[
.B \-\-trace
]
[
.B \-\-wait
]
.I filename
[
.I scenario\-options
]
.SH DESCRIPTION
"MASL(Memorymapped Animation Scenario Language)"
is the animation program which has been developed by KUNI.
Xmasl is ported masl to X Window System.

.SH OPTIONS
.IP \-a,\-\-ahead 
enable function of extractintg image ahead.(default)
when specifing \-\-static or \-\-STATIC this option is ignored.)
.IP \-b,\-\-break
Wait for key each when command executed.Off cource this option
is nonsence without specify --debug option.(compile option)
.IP \-c,\-\-comment
print the comment.(default)
.IP \-\-commentless
print no comment before playing.
.IP \-d,\-\-debug
debug mode.(compile option)
.IP \-\-demand
Disable function of extracting image ahead.
.IP \-e,\-\-euc
print comment by Japanese EUC code.(default)
.IP \-f,\-\-force400line
Display image with 400 line mode
even when 200 line mode is specified in the data.
.IP \-\-full
display all 98VRAM.When enable this option mask function is disabled.
.IP \-h,\-\-help
Print usage and exit.
.IP \-\-mask
Enable mask function.(default)
.IP \-\-maskless
Disable mask function.
.IP \-m,\-\-mitshm
use MITSHM extention
.IP \-\-normal
Play data in normal mode.(Disable trace mode and debug mode)(default)
.IP \-n,\-\-nosound
Play data with no pcm.(but timer intruption is used
even when this option spesified)
.IP \-p,\-\-pause
Wait for key pressing when playing finished.
.IP \-R,\-\-RENICE
Play data with hegher scheduling priority.(compile option)
.IP \-r,\-\-resizable
Resizing window is able.(This option does not have much meaningss)
.IP \-\-realtime
extracting image data at real timely.(default)
.IP \-S,\-\-STATIC
extract all image on memory before playing.this makes playing faster a bit.
\-\-STATIC use less memory than --static,but less faster.
.IP \-s,\-\-static
extract all image on memory before playing.this makes playing faster a bit.
but use a lot of memory.
.IP \-\-sjis
print the comment with sjis code.
.IP \-\-sound
Play data with pcm.(default)(Off cource if you compile xmasl
with no pcm,this option is nonsense)
.IP \-t,\-\-trace
trace mode.Wait for key or click each when put the image.
By pressing return key or clicking button2,you turn from trace mode
to normal mode.
.IP \-w,\-\-wait
Wait for key before playing data.(Start playing after passing
the specified seconds in the data.)

.SH "KEY BINDINGS"
Pressing button2 iconify the window.(but pcm is not stopped)
Pressing button1 pauses playing data.(but pcm is not stopped)
Dragging button1 pasts the area on root window when pause.(Wall paper funciton)
Clicking button2 or button3 or Pressing any key restart playing.
Pressing ESC key finishes playing.

.SH "DEBUG MODE"
Use debug mode and you will find what debug mode is.
when specified \-\-break,wait for space,b.Pressing return,c,m toggle
break mode.
Left or right(cursor key or l,h or f,b or C\-f,C\-b or 4,6) moves window
of variables.
Up or down(cursor key or k,j or p,n or C-p,C-n or u,d) moves window of
scenario.
Pressing N,J,D,v,C\-v page down or Pressing P,K,V,z,U backspace,page up
moves half of window of scenario.
Pressing home recenter window of scenario.
Pressing C\-l redraw screen.

.SH RESOURCES
resourceoptionͥ褷ޤ

.TP 8
.B "isAhead (\fPclass\fB IsAhead)"
ŸԤʤݤ
True:Ԥʤ
False:Ԥʤʤ
The default is True.

.TP 8
.B "isStaticLowMemory (\fPclass\fB IsStaticLowMemory)"
dataŪŸƤݤ
True:ŪŸ롣ξpCell[i]¤CellStaticؤˤʤ롣
False:ưŪŸ롣
Ȥΰ㤤memoryξ̤꾯ʤ
The default is False.

.TP 8
.B "isStatic (\fPclass\fB IsStaitc)"
dataŪŸƤݤ
True:ŪŸ롣ξpCell[i]¤CellStaticؤˤʤ롣
False:ưŪŸ롣
The default is False.

.TP 8
.B "isTraceMode (\fPclass\fB IsTraceMode)"
mode
True:modeˤ롣
False:modeˤʤ
The default is False.

.TP 8
.B "isNoSound (\fPclass\fB IsNoSound)"
PCM뤫ݤ
True:ʤ
False:롣
The default is False.

.TP 8
.B "isNoPrintComment (\fPclass\fB IsNoPrintComment)"
ϻcommentɽ뤫ݤ
Trueɽʤ
Falseɽ롣
The default is False.

.TP 8
.B "isWaitBeforePlaying (\fPclass\fB IsWaitBeforePlaying)"
keyԤ򤹤뤫ݤ
True:롣
False:ˤ˺
The default is False.

.TP 8
.B "isPause (\fPclass\fB IsPause)"
λkeyԤ򤹤뤫
True:롣
False:ʤ
The default is False.

.TP 8
.B "isForce400LineMode (\fPclass\fB IsForce400LineMode)"
200line modeǤ⶯Ū400line modeɽ롣
True:400line modeˤ롣
False:ʤ
The default is False.

.TP 8
.B "isWindowResizable (\fPclass\fB IsWindowResizable)"
windowsizeѹ
True:
False:sizeѹǤʤ
The default is False.

.TP 8
.B "isSjis (\fPclass\fB IsSjis)"
commentɽsjisǹԤʤ
True:sjisǹԤʤ
False:eucǹԤʤ
The default is False.

.TP 8
.B "isFullsize (\fPclass\fB IsFullSize)"
98VRAMΤɽ뤫
True:롣
False:ʤ(̾ɽ)
The default is False.

.TP 8
.B "isRenice (\fPclass\fB IsRenice)"
processμ¹̤ͥ夲뤫
True:夲롣
False:夲ʤ
suidƤʤȽʤ
The default is False.

.TP 8
.B "isDebugMode (\fPclass\fB IsDebugMode)"
debug modeݤ
True:debug mode.
False:normal mode.
The default is False.

.TP 8
.B "isBreakMode (\fPclass\fB IsBreakMode)"
debug modeλcommandŤߤ뤫ݤ
True:ߤ롣
False:ߤʤ
optionisDebugMode==TrueǤʤа̣ʤʤ
The default is False.

.TP 8
.B "useMask (\fPclass\fB UseMask)"
maslѤ뤫ݤ
True:Ѥ롣
False:Ѥʤ
The default is True.

.SH COPYRIGHT
MASL/M\-MASL Copyright (c) KUNI/TDU(ORIGINAL)
.br
Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
.br
X Window System version Copyright (c)1997 Yamahata Isaku (ISA\-9)

.SH FILES

.SH "SEE ALSO"
.BR xmm (1x)

.SH BUGS
See the BUGS file,the FUNCION file and the TODO file in the distribution.

.SH AUTHOR
Isaku Yamahata
.br
<yamahata@kusm.kyoto-u.ac.jp>
.br
<CQG00274@niftyserve.or.jp>
.sp
Special Thanx to:
.sp
AOI,
Daisuke Iizuka,
Daisuke Kanda,
Daisuke Nagano,
Kei Hibino,
Kenji Kitaoka,
Kuni,
Masahito Ohtsuka,
Shigeo Mitsunari,
shimarin,
shochan,
Takasi Shirai,
Zenmai
