/* 
        MaslConst.h

	MASL/M-MASL Copyright (c) KUNI/TDU
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
	X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)
*/
#include <string.h>
//#include <cstring>
#include <X11/Xlib.h>

#ifndef masl_const_h
#define masl_const_h

#define APP_CLASS_NAME "XMasl"

#define SIZE_X 640 //pixel
#define SIZE_Y 400 //pixel
#define VERTICAL_OFFSET (480-400)/2  //svgalib verλˤ餷ɽ
                                     //(̤ɽ롣)
#define PLANE_LENGTH (SIZE_X*SIZE_Y/8)//ñ̤byte
#define VRAM_LENGTH 32768//=0x8000=0x7fff+1:98VRAM addressθ³
                         //=640*409/8
#define VRAM_SIZE_Y (VRAM_LENGTH*8/SIZE_X)

#define DEPTHOFAK5 4
#define NUMBER_OF_COLORS 16 //=(1 << DEPTHAOFAK5)

#define MAXCELL 2048//ak5κ
#define MAXPAL 256//paletteκ
#define MAXPCM 256//PCM dataκ
#define MAXVAR 256//ѿκ

//ak5 id
#define AK5ID_PAL       0//palette
#define AK5ID_NORM      1//Ρޥ륻
#define AK5ID_DIFF      2//ʬ
#define AK5ID_NORM_FAST 3//®Ρޥ륻
#define AK5ID_DIFF_FAST 4//®ʬ

/////masldefaultsampleing rate
#define DEFAULT_SAMPLE_RATE 16540
//defaultsampling rateĤʤΤΤʤ
//ͤϻŪˤƤޤ

class RECT
{
public:
  int left;
  int top;
  int right;
  int bottom;

  RECT (){};
  RECT (int x1,int y1,int x2,int y2):
    left (x1),top (y1),right (x2),bottom (y2)
    {};
};

class XMASL_OPTION
{
public:
#ifdef MITSHM
  Bool isUseMITSHM;
#endif
  Bool isAhead;
  //ŸԤʤݤ
  //=True:Ԥʤ =False:Ԥʤʤ
  Bool isStaticLowMemory;
  //dataŪŸƤݤ
  //=True:ŪŸ롣ξpCell[i]¤CellStaticؤˤʤ롣
  //=False:ưŪŸ롣
  //Ȥΰ㤤memoryξ̤꾯ʤ
  Bool isStatic;
  //dataŪŸƤݤ
  //=True:ŪŸ롣ξpCell[i]¤CellStaticؤˤʤ롣
  //=False:ưŪŸ롣
  Bool isTraceMode;
  //modeȸäƤºݤ1command˼¹ԤƤΤ
  Bool isNoSound;
  //PCM뤫ݤ
  //=True:ʤ =False:
  Bool isNoPrintComment;
  //ϻcommentɽ뤫ݤ
  //True=ɽʤ False=ɽ
  Bool isWaitBeforePlaying;
  //keyԤ򤹤뤫ݤ
  //=True: =False:ˤ˺
  Bool isPause;
  //λkeyԤ򤹤뤫
  //=True: =:Falseʤ
  Bool isForce400LineMode;
  //200line modeǤ⶯Ū400line modeɽ
  Bool isWindowResizable;
  //windowsizeѹ
  //=True: =False:sizeѹǤʤ
  Bool isSjis;//commentɽsjisǹԤʤ
  //=True:sjisǹԤʤ,=False:eucǹԤʤ
  Bool useMask;//maskԤʤ
  //=True:Ԥʤ =False:Ԥʤʤ
  Bool isFullsize;//98vramɽ
  //i.e. VRAM_LENGTH=640*409/8ʤΤ 640x409礭ɽ
  //=True: =False:ʤ
  Bool isUsePrivateColormap;//private colormapŪ˻Ѥ롣
  //=True:private color mapѤ롣
  //=False:common color map鿧ݤ褦Ȼߤ롣(ݤǤʤprivate color mapѤ롣)

#ifdef RENICE
# define RENICE_LEVEL -15
  Bool isRenice;
  //processμ¹̤ͥ夲뤫
  //=True:夲롣=False:夲ʤ
  //suidƤʤȽʤ
#endif

#ifdef DEBUG_MODE
  Bool isDebugMode;//debug modeݤ
  //=True:debug mode =False:normal mode
  Bool isBreakMode;//debug modeλcommandŤߤ뤫ݤ
  //=True:ߤ =False:ߤʤ
  //optionisDebugMode==TrueǤʤа̣ʤʤ
  char* ttyOfDebugMode;
  //debug modeɽ뤿ttyꤹ롣
  //=NULLλcommand¹Ԥttyˤʤ롣
#endif// DEBUG_MODE

  XMASL_OPTION ()://default
#ifdef MITSH
    isUseMITSHM (False),
#endif
    isAhead (True),isStaticLowMemory (False),isStatic (False),
    isTraceMode (False),isNoSound (False),isNoPrintComment (False),
    isWaitBeforePlaying (False),isPause (False),
    isForce400LineMode (False),isWindowResizable (False),isSjis (False),
    useMask (True),isFullsize (False),isUsePrivateColormap (False)
#ifdef RENICE
    ,isRenice (False)
#endif //RENICE
#ifdef DEBUG_MODE
    ,isDebugMode (False),isBreakMode (False),ttyOfDebugMode (NULL)
#endif
    {/*⤷ʤ*/};

  XMASL_OPTION (XMASL_OPTION& src):
#ifdef MITSHM
    isUseMITSHM (src.isUseMITSHM),
#endif
    isAhead (src.isAhead),isStaticLowMemory (src.isStaticLowMemory),
    isStatic(src.isStatic), 
    isTraceMode (src.isTraceMode),
    isNoSound (src.isNoSound),
    isNoPrintComment (src.isNoPrintComment),
    isWaitBeforePlaying (src.isWaitBeforePlaying),
    isPause (src.isPause),isForce400LineMode (src.isForce400LineMode),
    isWindowResizable (src.isWindowResizable),isSjis (src.isSjis),
    useMask (src.useMask),isFullsize (src.isFullsize),
    isUsePrivateColormap (src.isUsePrivateColormap)
#ifdef RENICE
    ,isRenice (src.isRenice)
#endif
#ifdef DEBUG_MODE
    ,isDebugMode (src.isDebugMode),isBreakMode (src.isBreakMode),
    ttyOfDebugMode (NULL)
#endif//DEBUG_MODE
    {
#ifdef DEBUG_MODE
      if (src.ttyOfDebugMode!=NULL)
	{
	  ttyOfDebugMode=new char[strlen (src.ttyOfDebugMode)+1];
	  strcpy (ttyOfDebugMode,src.ttyOfDebugMode);
	}
#endif
    };

  ~XMASL_OPTION ()
    {
#ifdef DEBUG_MODE
      delete[] ttyOfDebugMode;
#endif
    };
};
#endif //masl_const_h
