/* 
        MaslScenario.h

        MASL/M-MASL Copyright (c) KUNI/TDU$B1~>p8&(B
        Windows version Copyright (c) 1995, 1996 Tomoatsu Shimada  (shimarin)
        X Window System version Copyright (c)1997 Yamahata Isaku (ISA-9)

        $B$3$N(Bcode$B$O(Bshimarin$B$5$s$N(Bcode$B$r85$K(BYamahata$B$,=q$-D>$7$?J*$G$9!#(B
*/
#include <assert.h>
//#include <cassert>
#include <X11/Xlib.h>
#include <X11/Xutil.h>

#include "MaslInputStream.h"
#include "Scenario.h"

#ifndef masl_scenario_h
#define masl_scenario_h
class MaslScenario:public Scenario
{
private:
  int hz;
  void init ();
public:
  MaslScenario (char* filename);
  MaslScenario (MaslInputStream& maslIs,int maslScenarioSize);
  MaslScenario (char* data,int maslScenarioSize);
  ~MaslScenario ();

  void showInfo ();
  Bool checkMagic ();
  inline int getTimerCounter () const {return hz;};
};
#endif masl_scneario_h
